searchNodes=[{"type":"module","title":"blockade","doc":"This module defines the public API for the blockade application.","ref":"blockade.html"},{"type":"function","title":"blockade.add_handler/2","doc":"Adds a handler to an event. The process calling the function will be added to the event group. Calling this function multiple times with the same event will add the process to the event group multiple times and the process will receive the event multiple times.","ref":"blockade.html#add_handler/2"},{"type":"function","title":"blockade.child_spec/1","doc":"Child spec for the blockade event manager supervisor.","ref":"blockade.html#child_spec/1"},{"type":"function","title":"blockade.discard_events/2","doc":"Boolean flag to enable or disable the event discarding feature. If the flag is set to true , the event queue will discard events that have lower priority than the event queue priority.","ref":"blockade.html#discard_events/2"},{"type":"function","title":"blockade.dispatch/3","doc":"Dispatches event asynchronously. The event will be dispatched to all the processes that are subscribed to the event. If no options are passed to the function, the event will be dispatched across the cluster.","ref":"blockade.html#dispatch/3"},{"type":"function","title":"blockade.dispatch/4","doc":"Dispatches event asynchronously with options. The event will be dispatched to all the processes that are subscribed to the event.","ref":"blockade.html#dispatch/4"},{"type":"function","title":"blockade.dispatch_sync/3","doc":"Dispatches event synchronously. The function will return when all messages are sent to the subscribed processes. This does not mean that all processes have handled the event because the messages are sent asynchronously. The event will be dispatched to all the processes that are subscribed to the event. If no options are passed to the function, the event will be dispatched across the cluster.","ref":"blockade.html#dispatch_sync/3"},{"type":"function","title":"blockade.dispatch_sync/4","doc":"Dispatches event synchronously with options. The function will return when all messages are sent to the subscribed processes. This does not mean that all processes have handled the event because the messages are sent asynchronously. The event will be dispatched to all the processes that are subscribed to the event. If no options are passed to the function, the event will be dispatched across the cluster.","ref":"blockade.html#dispatch_sync/4"},{"type":"function","title":"blockade.get_event_queue/1","doc":"Returns the list of queued events.","ref":"blockade.html#get_event_queue/1"},{"type":"function","title":"blockade.get_events/1","doc":"Returns a list of events registered under the event manager.","ref":"blockade.html#get_events/1"},{"type":"function","title":"blockade.get_handlers/2","doc":"Returns a list of process identifiers that are subscribed to the event.","ref":"blockade.html#get_handlers/2"},{"type":"function","title":"blockade.get_priority/1","doc":"Returns the priority of the event queue.","ref":"blockade.html#get_priority/1"},{"type":"function","title":"blockade.local_manager_state/1","doc":"Returns the state of the event manager.","ref":"blockade.html#local_manager_state/1"},{"type":"function","title":"blockade.prune_event_queue/1","doc":"Removes all queued events.","ref":"blockade.html#prune_event_queue/1"},{"type":"function","title":"blockade.remove_handler/2","doc":"Remove a handler from an event. The process calling the function will be removed from the event group.","ref":"blockade.html#remove_handler/2"},{"type":"function","title":"blockade.set_priority/2","doc":"Sets the priority of the event queue. The priority will be propagated to all the nodes in the cluster. Default priority is 0 .","ref":"blockade.html#set_priority/2"},{"type":"function","title":"blockade.set_priority/3","doc":"Sets the priority of the event queue with options. The priority will be propagated to all the nodes in the cluster. Optionally the priority can be reset after a certain number of milliseconds and events can be discarded if the priority of the event is lower than the priority of the event queue. Default priority is 0 .","ref":"blockade.html#set_priority/3"},{"type":"function","title":"blockade.start_link/1","doc":"Start a blockade event manager supervisor.","ref":"blockade.html#start_link/1"},{"type":"type","title":"blockade.dispatch_opts/0","doc":"Dispatch options.","ref":"blockade.html#t:dispatch_opts/0"},{"type":"type","title":"blockade.event/0","doc":"Event payload which can be any term.","ref":"blockade.html#t:event/0"},{"type":"type","title":"blockade.event_discard/0","doc":"Boolean indicating whether to discard events or not in case the priority of the event is lower than the priority of the event manager.","ref":"blockade.html#t:event_discard/0"},{"type":"type","title":"blockade.event_manager/0","doc":"The name of the event.","ref":"blockade.html#t:event_manager/0"},{"type":"type","title":"blockade.event_payload/0","doc":"Boolean indicating whether the priority should be synchronized within the cluster.","ref":"blockade.html#t:event_payload/0"},{"type":"type","title":"blockade.priority/0","doc":"Boolean indicating whether to discard events or not when the priority of the event is lower than the priority of the event manager.","ref":"blockade.html#t:priority/0"},{"type":"type","title":"blockade.priority_opts/0","doc":"Priority options.","ref":"blockade.html#t:priority_opts/0"},{"type":"type","title":"blockade.priority_sync/0","doc":"Priority level. The higher the priority the more important the event.","ref":"blockade.html#t:priority_sync/0"},{"type":"type","title":"blockade.queued_event/0","doc":"Queued event.","ref":"blockade.html#t:queued_event/0"},{"type":"type","title":"blockade.start_up_opts/0","doc":"Start up options which can be passed to the start_link function.","ref":"blockade.html#t:start_up_opts/0"},{"type":"extras","title":"Blockade","doc":"","ref":"readme.html"},{"type":"extras","title":"Blockade - Table of contents","doc":"Blockade Description Setup Elixir Erlang Example usage Elixir Erlang Using priority option Distributed environment dispatching Dispatching options: Disable priority synchronization Development Setup with Docker Running tests","ref":"readme.html#table-of-contents"},{"type":"extras","title":"Blockade - Description","doc":"Blockade provides a simple way to queue and dispatch events to subscribers. Blockade enables you to set a priority level on the event queue. This allows you to handle events later or discard them completely when dispatched with lower priority than the current priority level on the event queue. This can be handy in situations where you want to lock down the system and not process any events for some duration of time. In such cases, you can set a high priority level. Later, when the system is ready to handle events again, you can lower the priority level, and the queued events will be automatically dispatched (unless the discard_events option is set to true ). Blockade is built on top of the Erlang pg module, which means it will work in a distributed environment. Each node starts the blockade supervisor with the same name parameter. When dispatching events, the events will be received by all subscribers across the cluster. When process dies or is terminated, the process will be unsubscribed from the event queue automatically. Please read the documentation for the blockade module for more information on the available functions.","ref":"readme.html#description"},{"type":"extras","title":"Blockade - Setup","doc":"Blockade can be started under supervision tree in your application. When starting blockade you need to provide a name for the event queue. This name is used when dispatching events to the queue. Elixir Add the following to your mix.exs file: { :blockade , &quot;~&gt; 0.2&quot; } , Start blockade under your supervision tree alias :blockade , as : Blockade def init ( _ ) do children = [ { Blockade , %{ name : :my_event_queue } } , ] opts = [ strategy : :one_for_one ] Supervisor . init ( children , opts ) end Erlang Add the following to your rebar.config file: Add blockade as a dependency { deps , [ { blockade , &quot;0.2.1&quot; } ] } . Start blockade under your supervision tree init ( Args ) -&gt; Children = [ \#{ id =&gt; blockade , start =&gt; { blockade , start_link , [ \#{ name =&gt; my_event_queue } ] } } ] , { ok , { { one_for_one , 5 , 10 } , Children } } .","ref":"readme.html#setup"},{"type":"extras","title":"Blockade - Example usage","doc":"Note When adding handlers to the event queue, the current process will be subscribed to the event queue. If subscribed multiple times, the process will receive the event multiple times. Elixir &gt; alias :blockade , as : Blockade &gt; Blockade . add_handler ( :my_event_queue , :event_key ) :ok &gt; Blockade . dispatch ( :my_event_queue , :event_key , &quot;event_payload&quot; ) :ok &gt; Blockade . dispatch ( :my_event_queue , :event_key , &quot;something_else&quot; ) :ok &gt; flush ( ) { :event_key , &quot;event_payload&quot; } { :event_key , &quot;something_else&quot; } Erlang &gt; blockade : add_handler ( my_event_queue , event_key ) . ok &gt; blockade : dispatch ( my_event_queue , event_key , &quot;event_payload&quot; ) . ok &gt; blockade : dispatch ( my_event_queue , event_key , &quot;something_else&quot; ) . ok &gt; flush ( ) . { event_key , &quot;event_payload&quot; } { event_key , &quot;something_else&quot; } Using priority option &gt; alias :blockade , as : Blockade # Subscribe current process to event with the key :some_event_key &gt; Blockade . add_handler ( :my_event_queue , :some_event_key ) :ok # Set priority to 100 and reset back to 0 (default) after 30 seconds. Do not discard any queued events. # If discard events is set to true, events with lower priority than the current priority will be discarded immediately after dispatching the event. &gt; Blockade . set_priority ( :my_event_queue , 100 , %{ reset_after : 30000 , discard_events : false } ) :ok # Immediately dispatch event with priority 100 and check local mailbox for any events. # There should be none if checked within 30 seconds after setting priority. &gt; Blockade . dispatch ( :my_event_queue , :some_event_key , &quot;priority_test&quot; ) :ok &gt; flush ( ) :ok # Wait 30 seconds and check local mailbox again. There should be one event now. &gt; flush ( ) { :some_event_key , &quot;priority_test&quot; } # Now lets try dispatching events with priority option. # Set priority to 150 and discard any queued events with lower priority. # This time the event queue will keep the priority and does not reset back to 0 because we did not provide the reset_after option. &gt; Blockade . set_priority ( :my_event_queue , 150 , %{ discard_events : true } ) :ok &gt; Blockade . dispatch ( :my_event_queue , :some_event_key , &quot;will_be_discarded&quot; , %{ priority : 149 } ) :ok &gt; Blockade . dispatch ( :my_event_queue , :some_event_key , &quot;will_be_received prio 150&quot; , %{ priority : 150 } ) :ok &gt; Blockade . dispatch ( :my_event_queue , :some_event_key , { :my_data , &quot;will_be_received prio 151&quot; } , %{ priority : 151 } ) :ok &gt; flush ( ) # We can see that the dispatched event with lower priority than 150 was discarded. { :some_event_key , &quot;will_be_received prio 150&quot; } { :some_event_key , { :my_data , &quot;will_be_received prio 151&quot; } } We can also set the discard_event option to true per dispatch call meaning the event will be discarded if priority level on the event queue is higher than the priority level on the dispatch call: &gt; Blockade . set_priority ( :my_event_queue , 150 , %{ discard_events : false } ) &gt; Blockade . dispatch ( :my_event_queue , :some_event_key , &quot;will_be_discarded&quot; , %{ priority : 149 , discard_event : true } ) :ok &gt; flush ( ) # The event will be discarded and wont be received by the handler.","ref":"readme.html#example-usage"},{"type":"extras","title":"Blockade - Distributed environment dispatching","doc":"By default blockade will dispatch events to all subscribers across the cluster. If you want to dispatch to local handlers only, you can set the members option to local when dispatching the event: # This event will be received by all handlers across the cluster. &gt; Blockade . dispatch ( :my_event_queue , :some_event_key , &quot;global_dispatch&quot; , %{ members : :global } ) :ok # This event will be received by local node handlers only. &gt; Blockade . dispatch ( :my_event_queue , :some_event_key , &quot;local_dispatch&quot; , %{ members : :local } ) :ok Disable priority synchronization Dispatching options: members - define which members should receive the event. available options are: global - dispatch event to all members within the cluster. local - dispatch event to local handlers only. external - dispatch event to all nodes except the local node. [node()] - dispatch event to a specified list of nodes. Default is global . priority - set priority level for the event. Default is 0 . The if current priority on the event queue is higher than the priority level on the dispatch call, the event will be discarded or queued depending on the discard_events option. discard_event - if set to true , the event will be discarded if priority level on the event queue is higher than the priority level on the dispatch call. Default is false . atomic_priority_set - if set the priority level will be set atomically according to the passed value. This is handy when we want to dispatch event and immediately set the priority level to a higher value. Disable priority synchronization In some cases, you might want to disable priority synchronization and keep priority level local to the node. This can be achieved by setting the priority_sync option to false when starting the blockade supervisor. Also keep in mind to set the local_priority_set option to true when setting the priority level or dispatching events with priority option. Elixir: alias :blockade , as : Blockade # Start blockade supervisor with priority_sync set to false. def init ( _ ) do children = [ { Blockade , %{ name : :my_event_queue , priority_sync : false } } , ] opts = [ strategy : :one_for_one ] Supervisor . init ( children , opts ) end # Set priority level to 100 and keep it local to the node. &gt; Blockade . set_priority ( :my_event_queue , 100 , %{ local_priority_set : true } ) # Dispatch event with priority level 100 and keep it local to the node. &gt; Blockade . dispatch ( :my_event_queue , :some_event_key , &quot;priority_test&quot; , %{ priority : 100 , local_priority_set : true , atomic_priority_set : true } ) Erlang: init ( Args ) -&gt; Children = [ \#{ id =&gt; blockade , start =&gt; { blockade , start_link , [ \#{ name =&gt; my_event_queue , priority_sync =&gt; false } ] } } ] , { ok , { { one_for_one , 5 , 10 } , Children } } . % Set priority level to 100 and keep it local to the node. blockade : set_priority ( my_event_queue , 100 , \#{ local_priority_set =&gt; true } ) . % Dispatch event with priority level 100 and keep it local to the node. blockade : dispatch ( my_event_queue , some_event_key , &quot;priority_test&quot; , \#{ priority =&gt; 100 , local_priority_set =&gt; true , atomic_priority_set =&gt; true } ) . Note If dispatching events to all members across the cluster is not desired, you can start blockade with different names on different nodes. This way you can have multiple event queues within the cluster each completly isolated from each other. For example you can use the local node name as the event queue name which is unique in the cluster.","ref":"readme.html#distributed-environment-dispatching"},{"type":"extras","title":"Blockade - Development","doc":"Setup with Docker docker-compose up -d docker exec -it blockade_blockade_1 sh rebar3 compile Running tests $ rebar3 compile &amp;&amp; ct_run -dir test -logdir test_logs -pa ./_build/default/lib/blockade/ebin -setcookie cookievalue","ref":"readme.html#development"},{"type":"extras","title":"LICENSE","doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS Copyright 2023, Anuar Alfetahe &lt;anuar.alfetahe@gmail.com&gt;. Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html"}]